  clf;
  axis equal

% Data (r, max_rho_k, asymptotic_rho_k)

  rate = [ ...
%   1.e-02  9.982e-01  9.982e-01
%   5.e-02  9.955e-01  9.853e-01
    1.e-01  9.951e-01  9.951e-01
%   2.e-01  9.820e-01  9.438e-01
%   3.e-01  9.735e-01  9.180e-01
%   4.e-01  9.650e-01  8.936e-01
%   5.e-01  9.560e-01  8.705e-01
%   6.e-01  9.461e-01  8.485e-01
%   9.e-01  9.085e-01
    1.e+00  9.697e-01  9.697e-01
%   2.e+00  6.269e-01  6.269e-01
    3.e+00  9.142e-01  9.142e-01
%   4.e+00  4.565e-01  4.565e-01
%   5.e+00  4.019e-01  4.019e-01
    1.e+01  7.617e-01  7.616e-01
%   2.e+01  1.438e-01  1.438e-01
    3.e+01  5.158e-01  5.157e-01
%   4.e+01  7.749e-02  7.749e-02
%   5.e+01  6.297e-02  6.297e-02
%   7.e+01  4.580e-02  4.580e-02
    1.e+02  2.421e-01  2.421e-01
%   2.e+02  9.620e-02  9.620e-02
%   5.e+02  6.675e-03  6.675e-03
    1.e+03  3.079e-02  3.079e-02
%   1.e+04  1.686e-02  1.686e-02
  ];

% Plot rates as a function of r

  loglog(rate(:,1),rate(:,2),'b','Linewidth',3);
  hold on
  loglog(rate(:,1),rate(:,3),'--b','Linewidth',2);

% Compute L, plot the line L/r, and print the value of L

  L = 0;
  n = size(rate,1);
  for i = 1:n
    L = max(L,rate(i,1)*rate(i,2));
  end
  Lstring = sprintf('L=%g',L);
  loglog(rate(:,1),L./rate(:,1),'r','Linewidth',1);

  xl = xlim;
  x1 = xl(1);
  yl = ylim;
  y1 = yl(1);
  loglog([1 1],[y1 L],'--k','Linewidth',1);
  loglog([x1 1],[L L],'--k','Linewidth',1);
  loglog(1,L,'.r','MarkerSize',20);

% text(1.5,L,'L=3.356','FontSize',15,'Color','red');
  text(1.5,L,Lstring,'FontSize',15,'Color','red');

% Plot the rate 1

  loglog(rate(:,1),ones(1,n),'r','Linewidth',1);

% Print the figure

  print -depsc rate_convergence_shift.eps

